# /usr/bin/python

import json

from Netzwerkzugriff import *
from AntwortParser import *


class Socialbot:
    """
    Dies ist ein einfacher Social Bot, der posten, alle Beiträge auf seiner eigene Pinnwand liken, 
    sowie alle eigenen Posts und die User des Netzwerks ausgeben kann.
    Beim Erzeugen sind gültige Benutzerdaten nötig.
    """ 
    def __init__(self, usernameNeu, passwordNeu):
        self._username = usernameNeu
        self._password = passwordNeu
        self._socialbotnet = Netzwerkzugriff("https://www.socialbotnet.de")
        print("Bot angemeldet")

    def postsAusgeben(self):
        antwort = self._socialbotnet.GETAnfrageSenden(f"/api/pinnwand/{self._username}")
        print(antwort)

    def postsFormatiertAusgeben(self):
        antwort = self._socialbotnet.GETAnfrageSenden(f"/api/pinnwand/{self._username}")
        posts = AntwortParser().zuPostArray(antwort)

        for p in posts:
            print("id:", p.getId())
            print("likedBy:", p.getLikedBy())
            print("message:", p.getMessage())
            print("publischingDate:", p.getPublishingDate())
            print("userID und userName:", p.getUserId(), p.getUsername())
            print("wall:", p.getWall().getUsername())
            print("----------------------------------------")


    def posten(self, nachricht):
        self._socialbotnet.POSTAnfrageSenden("/api/post", username=self._username, password=self._password,
                                     message=nachricht)


    def liken(self, id):
        self._socialbotnet.POSTAnfrageSenden("/api/like", username=self._username, password=self._password,
                                             postid=str(id))

    def eigenePinnwandLiken(self):
        antwort = self._socialbotnet.GETAnfrageSenden(f"/api/pinnwand/{self._username}")
        posts = AntwortParser().zuPostArray(antwort)
        for post in posts:
            id = post.getId()
            self.liken(id)

# Von dieser Klasse muss mit passenden Anmeldedaten ein Objekt erzeugt werden, 
# dann können entsprechende Methodenaufrufe stattfinden
